#define EOL '\n'
#define TRUE 1
#define FALSE 0
#define MAX_LEN 1000

#define MWFIT_PGM	"/space/home/phx-ugm/bin/mwfit"
#define DATA_DIR	"/space/home/phx-ugm/grids_run"

/* tags for data reading */
#define MEAN	0
#define VARIANCE	1

#define CLASS	0
#define LANDSC	1

#define	MAX_C_RUNS	35

int	FRACTAL;

char	RUN_DIR[MAX_LEN];
char	LOG_DIR[MAX_LEN];
char	OUTDIR[MAX_LEN];
char	SFX[MAX_LEN];
int	RUN_FLAG, LOG_FLAG;
int	NEI_RQMT, NEI_HOOD;


struct class_res {
	float	CA_VAL;
	float	TA_VAL;
	float	LAND_VAL;
	float	LPI_VAL;
	float	NP_VAL;
	float	PD_VAL;
	float	MPS_VAL;
	float	PSSD_VAL;
	float	PSCV_VAL;
	float	TE_VAL;
	float	ED_VAL;
	float	LSI_VAL;
	float	MSI_VAL;
	float	AWMSI_VAL;
	float	DLFD_VAL;
	float	MPFD_VAL;
	float	AWMPFD_VAL;
	float	CLAND_VAL;
	float	TCA_VAL;
	float	NCA_VAL;
	float	CAD_VAL;
	float	MCA1_VAL;
	float	CASD1_VAL;
	float	CACV1_VAL;
	float	MCA2_VAL;
	float	CASD2_VAL;
	float	CACV2_VAL;
	float	TCAI_VAL;
	float	MCAI_VAL;
	float	MNN_VAL;
	float	NNSD_VAL;
	float	NNCV_VAL;
	float	IJI_VAL;
};
struct land_res {
	float	TA_VAL;
	float	LPI_VAL;
	float	NP_VAL;
	float	PD_VAL;
	float	MPS_VAL;
	float	PSSD_VAL;
	float	PSCV_VAL;
	float	TE_VAL;
	float	ED_VAL;
	float	LSI_VAL;
	float	MSI_VAL;
	float	AWMSI_VAL;
	float	DFLD_VAL;
	float	MPFD_VAL;
	float	AWMPFD_VAL;
	float	TCA_VAL;
	float	NCA_VAL;
	float	CAD_VAL;
	float	MCA1_VAL;
	float	CASD1_VAL;
	float	CACV1_VAL;
	float	MCA2_VAL;
	float	CASD2_VAL;
	float	CACV2_VAL;
	float	TCAI_VAL;
	float	MCAI_VAL;
	float	MNN_VAL;
	float	NNSD_VAL;
	float	NNCV_VAL;
	float	SHDI_VAL;
	float	SIDI_VAL;
	float	MSIDI_VAL;
	float	PR_VAL;
	float	PRD_VAL;
	float	RPR_VAL;
	float	SHEI_VAL;
	float	SIEI_VAL;
	float	MSIEI_VAL;
	float	IJI_VAL;
	float	CONTAG_VAL;
};

struct PASS_LIST {
	float	gene[6];
	float	leesallee;
	float	mwfit;
	struct 	class_res class_urban_res;
	struct 	land_res land_res;
	struct 	PASS_LIST *next_p;
	struct 	PASS_LIST *prev_p;
};

struct PASS_LIST	*PASS_LIST_P, *TMP_PASS_LIST_P;


struct class_data_tab {
	int	COUNT;
	float	CA_SUM;
	float	TA_SUM;
	float	LAND_SUM;
	float	LPI_SUM;
	float	NP_SUM;
	float	PD_SUM;
	float	MPS_SUM;
	float	PSSD_SUM;
	float	PSCV_SUM;
	float	TE_SUM;
	float	ED_SUM;
	float	LSI_SUM;
	float	MSI_SUM;
	float	AWMSI_SUM;
	float	DLFD_SUM;
	float	MPFD_SUM;
	float	AWMPFD_SUM;
	float	CLAND_SUM;
	float	TCA_SUM;
	float	NCA_SUM;
	float	CAD_SUM;
	float	MCA1_SUM;
	float	CASD1_SUM;
	float	CACV1_SUM;
	float	MCA2_SUM;
	float	CASD2_SUM;
	float	CACV2_SUM;
	float	TCAI_SUM;
	float	MCAI_SUM;
	float	MNN_SUM;
	float	NNSD_SUM;
	float	NNCV_SUM;
	float	IJI_SUM;
	float	CA_MEAN;
	float	TA_MEAN;
	float	LAND_MEAN;
	float	LPI_MEAN;
	float	NP_MEAN;
	float	PD_MEAN;
	float	MPS_MEAN;
	float	PSSD_MEAN;
	float	PSCV_MEAN;
	float	TE_MEAN;
	float	ED_MEAN;
	float	LSI_MEAN;
	float	MSI_MEAN;
	float	AWMSI_MEAN;
	float	DLFD_MEAN;
	float	MPFD_MEAN;
	float	AWMPFD_MEAN;
	float	CLAND_MEAN;
	float	TCA_MEAN;
	float	NCA_MEAN;
	float	CAD_MEAN;
	float	MCA1_MEAN;
	float	CASD1_MEAN;
	float	CACV1_MEAN;
	float	MCA2_MEAN;
	float	CASD2_MEAN;
	float	CACV2_MEAN;
	float	TCAI_MEAN;
	float	MCAI_MEAN;
	float	MNN_MEAN;
	float	NNSD_MEAN;
	float	NNCV_MEAN;
	float	IJI_MEAN;
	float	CA_SDIFFSQR;
	float	TA_SDIFFSQR;
	float	LAND_SDIFFSQR;
	float	LPI_SDIFFSQR;
	float	NP_SDIFFSQR;
	float	PD_SDIFFSQR;
	float	MPS_SDIFFSQR;
	float	PSSD_SDIFFSQR;
	float	PSCV_SDIFFSQR;
	float	TE_SDIFFSQR;
	float	ED_SDIFFSQR;
	float	LSI_SDIFFSQR;
	float	MSI_SDIFFSQR;
	float	AWMSI_SDIFFSQR;
	float	DLFD_SDIFFSQR;
	float	MPFD_SDIFFSQR;
	float	AWMPFD_SDIFFSQR;
	float	CLAND_SDIFFSQR;
	float	TCA_SDIFFSQR;
	float	NCA_SDIFFSQR;
	float	CAD_SDIFFSQR;
	float	MCA1_SDIFFSQR;
	float	CASD1_SDIFFSQR;
	float	CACV1_SDIFFSQR;
	float	MCA2_SDIFFSQR;
	float	CASD2_SDIFFSQR;
	float	CACV2_SDIFFSQR;
	float	TCAI_SDIFFSQR;
	float	MCAI_SDIFFSQR;
	float	MNN_SDIFFSQR;
	float	NNSD_SDIFFSQR;
	float	NNCV_SDIFFSQR;
	float	IJI_SDIFFSQR;
	float	CA_VARIANCE;
	float	TA_VARIANCE;
	float	LAND_VARIANCE;
	float	LPI_VARIANCE;
	float	NP_VARIANCE;
	float	PD_VARIANCE;
	float	MPS_VARIANCE;
	float	PSSD_VARIANCE;
	float	PSCV_VARIANCE;
	float	TE_VARIANCE;
	float	ED_VARIANCE;
	float	LSI_VARIANCE;
	float	MSI_VARIANCE;
	float	AWMSI_VARIANCE;
	float	DLFD_VARIANCE;
	float	MPFD_VARIANCE;
	float	AWMPFD_VARIANCE;
	float	CLAND_VARIANCE;
	float	TCA_VARIANCE;
	float	NCA_VARIANCE;
	float	CAD_VARIANCE;
	float	MCA1_VARIANCE;
	float	CASD1_VARIANCE;
	float	CACV1_VARIANCE;
	float	MCA2_VARIANCE;
	float	CASD2_VARIANCE;
	float	CACV2_VARIANCE;
	float	TCAI_VARIANCE;
	float	MCAI_VARIANCE;
	float	MNN_VARIANCE;
	float	NNSD_VARIANCE;
	float	NNCV_VARIANCE;
	float	IJI_VARIANCE;
} ;

struct	class_data_tab		CLASS_DATA;

struct land_data_tab {
	int	COUNT;
	float	LEE_SUM;
	float	MWFIT_SUM;
	float	TA_SUM;
	float	LPI_SUM;
	float	NP_SUM;
	float	PD_SUM;
	float	MPS_SUM;
	float	PSSD_SUM;
	float	PSCV_SUM;
	float	TE_SUM;
	float	ED_SUM;
	float	LSI_SUM;
	float	MSI_SUM;
	float	AWMSI_SUM;
	float	DFLD_SUM;
	float	MPFD_SUM;
	float	AWMPFD_SUM;
	float	TCA_SUM;
	float	NCA_SUM;
	float	CAD_SUM;
	float	MCA1_SUM;
	float	CASD1_SUM;
	float	CACV1_SUM;
	float	MCA2_SUM;
	float	CASD2_SUM;
	float	CACV2_SUM;
	float	TCAI_SUM;
	float	MCAI_SUM;
	float	MNN_SUM;
	float	NNSD_SUM;
	float	NNCV_SUM;
	float	SHDI_SUM;
	float	SIDI_SUM;
	float	MSIDI_SUM;
	float	PR_SUM;
	float	PRD_SUM;
	float	RPR_SUM;
	float	SHEI_SUM;
	float	SIEI_SUM;
	float	MSIEI_SUM;
	float	IJI_SUM;
	float	CONTAG_SUM;
	float	TA_MEAN;
	float	LPI_MEAN;
	float	NP_MEAN;
	float	PD_MEAN;
	float	MPS_MEAN;
	float	PSSD_MEAN;
	float	PSCV_MEAN;
	float	TE_MEAN;
	float	ED_MEAN;
	float	LSI_MEAN;
	float	MSI_MEAN;
	float	AWMSI_MEAN;
	float	DFLD_MEAN;
	float	MPFD_MEAN;
	float	AWMPFD_MEAN;
	float	TCA_MEAN;
	float	NCA_MEAN;
	float	CAD_MEAN;
	float	MCA1_MEAN;
	float	CASD1_MEAN;
	float	CACV1_MEAN;
	float	MCA2_MEAN;
	float	CASD2_MEAN;
	float	CACV2_MEAN;
	float	TCAI_MEAN;
	float	MCAI_MEAN;
	float	MNN_MEAN;
	float	NNSD_MEAN;
	float	NNCV_MEAN;
	float	SHDI_MEAN;
	float	SIDI_MEAN;
	float	MSIDI_MEAN;
	float	PR_MEAN;
	float	PRD_MEAN;
	float	RPR_MEAN;
	float	SHEI_MEAN;
	float	SIEI_MEAN;
	float	MSIEI_MEAN;
	float	IJI_MEAN;
	float	CONTAG_MEAN;
	float	TA_SDIFFSQR;
	float	LPI_SDIFFSQR;
	float	NP_SDIFFSQR;
	float	PD_SDIFFSQR;
	float	MPS_SDIFFSQR;
	float	PSSD_SDIFFSQR;
	float	PSCV_SDIFFSQR;
	float	TE_SDIFFSQR;
	float	ED_SDIFFSQR;
	float	LSI_SDIFFSQR;
	float	MSI_SDIFFSQR;
	float	AWMSI_SDIFFSQR;
	float	DFLD_SDIFFSQR;
	float	MPFD_SDIFFSQR;
	float	AWMPFD_SDIFFSQR;
	float	TCA_SDIFFSQR;
	float	NCA_SDIFFSQR;
	float	CAD_SDIFFSQR;
	float	MCA1_SDIFFSQR;
	float	CASD1_SDIFFSQR;
	float	CACV1_SDIFFSQR;
	float	MCA2_SDIFFSQR;
	float	CASD2_SDIFFSQR;
	float	CACV2_SDIFFSQR;
	float	TCAI_SDIFFSQR;
	float	MCAI_SDIFFSQR;
	float	MNN_SDIFFSQR;
	float	NNSD_SDIFFSQR;
	float	NNCV_SDIFFSQR;
	float	SHDI_SDIFFSQR;
	float	SIDI_SDIFFSQR;
	float	MSIDI_SDIFFSQR;
	float	PR_SDIFFSQR;
	float	PRD_SDIFFSQR;
	float	RPR_SDIFFSQR;
	float	SHEI_SDIFFSQR;
	float	SIEI_SDIFFSQR;
	float	MSIEI_SDIFFSQR;
	float	IJI_SDIFFSQR;
	float	CONTAG_SDIFFSQR;
	float	TA_VARIANCE;
	float	LPI_VARIANCE;
	float	NP_VARIANCE;
	float	PD_VARIANCE;
	float	MPS_VARIANCE;
	float	PSSD_VARIANCE;
	float	PSCV_VARIANCE;
	float	TE_VARIANCE;
	float	ED_VARIANCE;
	float	LSI_VARIANCE;
	float	MSI_VARIANCE;
	float	AWMSI_VARIANCE;
	float	DFLD_VARIANCE;
	float	MPFD_VARIANCE;
	float	AWMPFD_VARIANCE;
	float	TCA_VARIANCE;
	float	NCA_VARIANCE;
	float	CAD_VARIANCE;
	float	MCA1_VARIANCE;
	float	CASD1_VARIANCE;
	float	CACV1_VARIANCE;
	float	MCA2_VARIANCE;
	float	CASD2_VARIANCE;
	float	CACV2_VARIANCE;
	float	TCAI_VARIANCE;
	float	MCAI_VARIANCE;
	float	MNN_VARIANCE;
	float	NNSD_VARIANCE;
	float	NNCV_VARIANCE;
	float	SHDI_VARIANCE;
	float	SIDI_VARIANCE;
	float	MSIDI_VARIANCE;
	float	PR_VARIANCE;
	float	PRD_VARIANCE;
	float	RPR_VARIANCE;
	float	SHEI_VARIANCE;
	float	SIEI_VARIANCE;
	float	MSIEI_VARIANCE;
	float	IJI_VARIANCE;
	float	CONTAG_VARIANCE;
};

struct	land_data_tab		LAND_DATA;
