/*
 */
#include <stdio.h>
#define TRUE 1
#define FALSE 0
#define MAX_LEN 1000
#define EOL '\n'

extern char *optarg;
extern int getopt();
extern double atof();
extern int atoi();

#ifdef DEBUG
FILE *DBG_FILE;
#endif

int	d1_5=0, d1_35=0, d1_65=0, d1_95=0;
int	d2_5=0, d2_35=0, d2_65=0, d2_95=0;
int	d3_5=0, d3_35=0, d3_65=0, d3_95=0;
int	d4_5=0, d4_35=0, d4_65=0, d4_95=0;
int	added_cols=0;

main(argc, argv) 
int argc;
char *argv[];
{
	char	in_filename[MAX_LEN], out_filename[MAX_LEN], c;

	/* initialize */
	strcpy(out_filename, "");
	strcpy(in_filename, "");

#ifdef DEBUG
	DBG_FILE=fopen("debug_cstats", "w");
	(void)fprintf(DBG_FILE, "(%s %d) Enter Main\n", __FILE__, __LINE__);
	fflush(DBG_FILE);
#endif

	while ((c = getopt(argc, argv, "i:o:")) != EOF ) {
		switch (c) {
			case 'i':
				strcpy(in_filename, optarg);
				break;
			case 'o':
				strcpy(out_filename, optarg);
				break;
			default:
				printf("bad option >%c<\n", c);
				exit(0);
				break;
		}
	}
	if ((strcmp(in_filename, "") == 0) || (strcmp(out_filename, "") == 0)) {
#ifdef DEBUG
		fprintf(DBG_FILE, "arguments required, -i and -o \n");
		fflush(DBG_FILE);
#endif
		exit(0);
	}
#ifdef DEBUG
	fprintf(DBG_FILE, "in: %s  out: %s\n", 
	in_filename, out_filename);
	fflush(DBG_FILE);
#endif

	process(in_filename);
	return(0);
}

process(in_filename)
char	*in_filename;
{
	FILE	*fp_in;
	char	line[MAX_LEN], lee[MAX_LEN], opt_str[MAX_LEN];
	float	lee_val;
	int	d1, d2, d3, d4, d5, d6;

	/* open the file */
	if ((fp_in = fopen(in_filename, "r")) == NULL) {
#ifdef DEBUG
		(void)fprintf(DBG_FILE, "(%s %d) %s NOT found\n", __FILE__, __LINE__, in_filename);
		(void)fflush(DBG_FILE);
		return(-1);
#endif
	}
	while ( fgetline(line, fp_in) >= 0 ) {
#ifdef xDEBUG
		(void)fprintf(DBG_FILE, "(%s %d) line: %s\n", 
		__FILE__, __LINE__, line);
		(void)fflush(DBG_FILE);
#endif
		/* skip comments and blank lines */
		if (line[0] == '#' || line[0] == '\0') {
#ifdef DEBUG
			(void)fprintf(DBG_FILE, "(%s %d) comment or blank line\n", 
			__FILE__, __LINE__, line);
			(void)fflush(DBG_FILE);
#endif
			continue;
		}
		sscanf(line, "%s %f %s", lee, &lee_val, opt_str);
		parse_it(opt_str, &d1, &d2, &d3, &d4, &d5, &d6);
#ifdef DEBUG
		(void)fprintf(DBG_FILE, "(%s %d) lee:%f   d1:%d  d2:%d   d3:%d   d4:%d   d5:%d   d6:%d\n", 
		__FILE__, __LINE__, lee_val, d1, d2, d3, d4, d5, d6);
		(void)fflush(DBG_FILE);
#endif
		add_cols(lee_val, d1, d2, d3, d4, d5, d6);
	}
	print_stats();
	return(0);
}
/********************************************************************
********************************************************************/
print_stats()
{

#ifdef DEBUG
	(void)fprintf(DBG_FILE, "(%s %d) \n", __FILE__, __LINE__);
	(void)fflush(DBG_FILE);

	/*
	(void)fprintf(DBG_FILE, "Counted %d lines >= .55\n", added_cols);
	*/
	(void)fprintf(DBG_FILE, "Counted %d lines >= .55 && < .60\n", added_cols);
	(void)fprintf(DBG_FILE, "	%d had a 5 in col 1\n", d1_5);
	(void)fprintf(DBG_FILE, "	%d had a 35 in col 1\n", d1_35);
	(void)fprintf(DBG_FILE, "	%d had a 65 in col 1\n", d1_65);
	(void)fprintf(DBG_FILE, "	%d had a 95 in col 1\n", d1_95);

	(void)fprintf(DBG_FILE, "	%d had a 5 in col 2\n", d2_5);
	(void)fprintf(DBG_FILE, "	%d had a 35 in col 2\n", d2_35);
	(void)fprintf(DBG_FILE, "	%d had a 65 in col 2\n", d2_65);
	(void)fprintf(DBG_FILE, "	%d had a 95 in col 2\n", d2_95);

	(void)fprintf(DBG_FILE, "	%d had a 5 in col 3\n", d3_5);
	(void)fprintf(DBG_FILE, "	%d had a 35 in col 3\n", d3_35);
	(void)fprintf(DBG_FILE, "	%d had a 65 in col 3\n", d3_65);
	(void)fprintf(DBG_FILE, "	%d had a 95 in col 3\n", d3_95);

	(void)fprintf(DBG_FILE, "	%d had a 5 in col 4\n", d4_5);
	(void)fprintf(DBG_FILE, "	%d had a 35 in col 4\n", d4_35);
	(void)fprintf(DBG_FILE, "	%d had a 65 in col 4\n", d4_65);
	(void)fprintf(DBG_FILE, "	%d had a 95 in col 4\n", d4_95);
#endif
	return(0);
}
/********************************************************************
********************************************************************/
add_cols(lee_val, d1, d2, d3, d4, d5, d6)
float	lee_val;
int	d1, d2, d3, d4, d5, d6;
{

	/*
	if (lee_val >= 0.55) 
	*/
	if ((lee_val >= 0.55) && (lee_val < 0.60))
	{
		added_cols++;
		if (d1 == 5)  d1_5++;
		if (d1 == 35) d1_35++;
		if (d1 == 65) d1_65++;
		if (d1 == 95) d1_95++;
		if (d2 == 5)  d2_5++;
		if (d2 == 35) d2_35++;
		if (d2 == 65) d2_65++;
		if (d2 == 95) d2_95++;
		if (d3 == 5)  d3_5++;
		if (d3 == 35) d3_35++;
		if (d3 == 65) d3_65++;
		if (d3 == 95) d3_95++;
		if (d4 == 5)  d4_5++;
		if (d4 == 35) d4_35++;
		if (d4 == 65) d4_65++;
		if (d4 == 95) d4_95++;
	}
	return(0);
}
/********************************************************************
********************************************************************/
parse_it(opt_str, d1, d2, d3, d4, d5, d6)
char	*opt_str;
int	*d1, *d2, *d3, *d4, *d5, *d6;
{
	char	*str_p, val_str[MAX_LEN], *val_str_p;
	int	num_c = 0, var_count = 0;
	int	do_more = TRUE;

	str_p = opt_str;
	str_p++;
	while (do_more == TRUE) {
		strcpy(val_str, "");
		val_str_p = val_str;
		while ((*str_p != ',')&& (*str_p != ')')) {
			*val_str_p++ = *str_p++;
		}
		*val_str_p = '\0';
		if (var_count == 0)
			*d1 = atoi(val_str);
		if (var_count == 1)
			*d2 = atoi(val_str);
		if (var_count == 2)
			*d3 = atoi(val_str);
		if (var_count == 3)
			*d4 = atoi(val_str);
		if (var_count == 4)
			*d5 = atoi(val_str);
		if (var_count == 5)
			*d6 = atoi(val_str);
		var_count++;
		if (*str_p == ')')
			do_more = FALSE;
		else
			*str_p++;
	}
	return(0);
}
/********************************************************************
********************************************************************/

/* fgetline: get a line from a file
 * Assumes the line array is long enough for the input and that the file
 * is open.
 */
int fgetline(line, fp)
char 	*line;
FILE	*fp;
{

	char	c;
	int	count = 0;

#ifdef xDEBUG
	(void)fprintf(DBG_FILE, "(%s %d) Enter fgetline()\n", __FILE__, __LINE__);
#endif
	while (c = getc(fp))
	{
		*line = (char)c;
		if (*line == EOL || *line == EOF) break ;
		++line ;
		++count;
	}
	*line = '\0';
	/* return the length of the line */
	if (c == EOF) {
#ifdef xDEBUG
		(void)fprintf(DBG_FILE, "(%s %d) return -1 \n", __FILE__, __LINE__);
#endif
		return(-1);
	} else {
#ifdef xDEBUG
		(void)fprintf(DBG_FILE, "(%s %d) return %d\n", 
		__FILE__, __LINE__, count);
#endif
		return(count);
	}
}
