/*************************************************************************/
/* Edge.c - CALIBRATION VERSION                                          */
/* Cellular Automaton for Urban Growth Simulation, Keith Clarke May 1990 */
/* kclarke@everest.hunter.cuny.edu                                       */
/*************************************************************************/

#include "./defines.h"
#include "./typedefs.h"
#include "localdefs.h"

#ifdef DEBUG
extern FILE *DBG_FILE;
#endif

void
Edge(stats)
	STATS          *stats;
{
	int             i, j;
	int             edge, edges;
	int             area;
	int             x, y;

	edges = 0;
	area = 0;
	for (i = 0; i < nrows; i++) {
		for (j = 0; j < ncols; j++) {
			edge = FALSE;
			if (z[i][j] != 0) {
				area++;

		 		/* this does a 4 neighbor search: N, S, E, W */
				if (z[i - 1][j] == 0)
					edge = TRUE;
				if (z[i + 1][j] == 0)
					edge = TRUE;
				if (z[i][j - 1] == 0)
					edge = TRUE;
				if (z[i][j + 1] == 0)
					edge = TRUE;


				/* this does an 8 neighbor search */
				/*
				for (y = i - 1; y <= i + 1; y++) {
					for (x = j - 1; x <= j + 1; x++) {
						if (z[y][x] == 0) edge = TRUE;
					}
				}
				*/

				if (edge) {
					edges++;
				}
			}
		}
	}
	stats->area = area;
	stats->edges = edges;
#ifdef xDEBUG
(void)fprintf(DBG_FILE, "(%s %d) Area: %8.4f\n", __FILE__, __LINE__, (float)area);
(void)fflush(DBG_FILE);
#endif
}
