/*
 */
#include <stdio.h>
#include <math.h>
#define TRUE 1
#define FALSE 0

extern char *optarg;
extern int getopt();
extern double atof();

double calc_rate();

#define	POP_1890 10986
#define	POP_1912 39030
#define	POP_1934 138667
#define	POP_1955 465000
#define	POP_1975 1253400
#define	POP_1997 2720575

#define SFX "1k"

#ifdef DEBUG
FILE *DBG_FILE;
#endif

main(argc, argv) 
int argc;
char *argv[];
{

	int	initial_year, initial_pop;
	int	initial_density, initial_num_cells;
	int	num_cells_before;
	int	pop_now;
	int	start_year, stop_year, this_year, current_density;
	double  initial_rate, current_rate;

#ifdef DEBUG
	DBG_FILE=fopen("debug_rate", "w");
	(void)fprintf(DBG_FILE, "(%s %d) Enter Main\n", __FILE__, __LINE__);
	fflush(DBG_FILE);
#endif

	start_year = 1912;
	stop_year = 1995;
	initial_year = start_year;
	initial_pop = 39030; /* 1912 */
	initial_num_cells = 19; /* 1912 1000m grids */
	initial_density = 2054; /* 1912 1000m grids */
	initial_rate = calc_rate(POP_1912, POP_1934, 22);

	/* initialize the changing variables */
	num_cells_before = initial_num_cells;
	pop_now = initial_pop;
	current_rate = initial_rate;
	this_year = initial_year + 1;
	get_est_density(this_year, &current_density);

	while (this_year <= stop_year) {

		begin_spread(this_year, &pop_now, &num_cells_before, &current_rate, &current_density);
#ifdef DEBUG
(void)fprintf(DBG_FILE, "(%s %d) year: %d   pop_now: %d   nc_before: %d   cur_rate: %.5f  cur_den: %d\n",
__FILE__, __LINE__, this_year, pop_now, num_cells_before, current_rate, current_density);
fflush(DBG_FILE);
#endif
		this_year++;

	} /* end while not to stop year */
#ifdef DEBUG
	(void)fprintf(DBG_FILE, "(%s %d) Final urban: %d         final pop: %d\n",
	__FILE__, __LINE__, num_cells_before, pop_now);
	fflush(DBG_FILE);
#endif
	return(0);
}

