/*
 * turn the ^M at the end of the line into a space
 */
#include <stdio.h>
#define TRUE 1
#define FALSE 0
#define URBAN 4

extern char *optarg;
extern int getopt();
extern int atoi();

#ifdef DEBUG
FILE *DBG_FILE;
#endif

int	NROW, NCOL;

main(argc, argv) 
int argc;
char *argv[];
{
	char	in_filename[200];
	FILE	*fp_in;
	char 	c, lookie, str[20];
	int	in_flag = FALSE;

	/* initialize */
	NROW = 0; 
	NCOL = 0;
#ifdef DEBUG
	DBG_FILE=fopen("./debug_cu", "w");
	(void)fprintf(DBG_FILE, "(%s %d) Enter Main\n", __FILE__, __LINE__);
	fflush(DBG_FILE);
#endif

	strcpy(in_filename, "");
	while ((c = getopt(argc, argv, "i:r:c:")) != EOF ) {
		switch (c) {
			case 'i':
				strcpy(in_filename, optarg);
				in_flag = TRUE;
				break;
			case 'r':
				strcpy(str, optarg);
				NROW = atoi(str);
				break;
			case 'c':
				strcpy(str, optarg);
				NCOL = atoi(str);
				break;
			default:
				printf("bad option\n");
				exit(0);
				break;
		}
	}
	if (in_flag == FALSE) {
#ifdef DEBUG
		printf("Filename required\n");
		fprintf(DBG_FILE, "Filename required\n");
		fflush(DBG_FILE);
#endif
		exit(0);
	}
	if (NROW == 0 || NCOL == 0) {
#ifdef DEBUG
		printf("row and/or column missing (-r and -c)\n");
		fprintf(DBG_FILE, "-r and -c required\n");
		fflush(DBG_FILE);
#endif
		exit(0);
	}
#ifdef DEBUG
	fprintf(DBG_FILE, "input: %s   rows: %d    col: %d \n",
	in_filename, NROW, NCOL);
	fflush(DBG_FILE);
#endif

#ifdef DEBUG
	(void)fprintf(DBG_FILE, "(%s %d) \n", __FILE__, __LINE__);
	fflush(DBG_FILE);
#endif
	fp_in = fopen(in_filename, "r");

	read_array(fp_in, in_filename);
}

read_array(fp_in, in_filename)
FILE	*fp_in;
char	*in_filename;
{
	int 	i, j, digit_cnt=0, tot_row, tot_col;
	char	c, word[15];
	int	cur_row = 0, cur_col = 0;
	int	urban_cnt = 0;

#ifdef DEBUG
	fprintf(DBG_FILE, "Enter read_array()\n");
	fflush(DBG_FILE);
#endif
	if (fp_in == NULL) {
#ifdef DEBUG
		fprintf(DBG_FILE, "opening input %s failed\n", in_filename);
#endif
		exit(0);
	}
	/*
	 * find the next character position after the 6th newline
	 */
	for (i = 0; i < 6; i++) {
		while ((c = getc(fp_in)) != '\n') { ;}
	}

	cur_row = 0;
	cur_col = 0;

	tot_row = 0;
	tot_col = 0;

	while ((c = getc(fp_in)) != EOF) {
        	if ( c == '\015' ) 
        		continue;
		if (( c == ' ') || ( c == '\n')) {
			/* end of word */
			word[digit_cnt]  = '\0';
#ifdef xDEBUG
			fprintf(DBG_FILE, "found word %s\n", word);
			fflush(DBG_FILE);
#endif
			if (cur_row < NROW && cur_col < NCOL) {

				/* check the value */
				if ( (atoi(word)) == URBAN) {
					urban_cnt++;
				}
				tot_col++;
			}
			cur_col++;
			if (cur_col >= NCOL) {
				cur_row++;
				tot_row++;
				cur_col = 0;
				tot_col = 0;
			}
			digit_cnt = 0;
		}else {
			word[digit_cnt++]  = c;
		} /* it's not space or EOL */
	} /* end while */
#ifdef DEBUG
	fprintf(DBG_FILE, "Urban count = %d\n", urban_cnt);
	printf("Urban count = %d\n", urban_cnt);
	fflush(DBG_FILE);
#endif

}
