/*
 */
#include <stdio.h>
#define TRUE 1
#define FALSE 0

extern char *optarg;
extern int getopt();
extern int atoi();

#ifdef DEBUG
FILE *DBG_FILE;
#endif

int	NROW, NCOL;
int orig_arr[2000][2900];


main(argc, argv) 
int argc;
char *argv[];
{
	char	in_filename[200];
	FILE	*fp_in;
	char 	c;
	int		in_flag = FALSE;
	char	row_str[50], col_str[50];

	/* initialize */
#ifdef DEBUG
	DBG_FILE=fopen("./debug_dims", "w");
	/*
	(void)fprintf(DBG_FILE, "(%s %d) Enter Main\n", __FILE__, __LINE__);
	fflush(DBG_FILE);
	*/
#endif

	NROW = 0;
	NCOL = 0;
	strcpy(in_filename, "");
	while ((c = getopt(argc, argv, "i:r:c:")) != EOF ) {
		switch (c) {
			case 'i':
				strcpy(in_filename, optarg);
				in_flag = TRUE;
				break;
			case 'r':
				strcpy(row_str, optarg);
				NROW = atoi(row_str);
				break;
			case 'c':
				strcpy(col_str, optarg);
				NCOL = atoi(col_str);
				break;
			default:
				printf("bad option\n");
				exit(0);
				break;
		}
	}
	if (in_flag == FALSE) {
#ifdef DEBUG
		printf("Filename required\n");
		fprintf(DBG_FILE, "Filename required\n");
		fflush(DBG_FILE);
#endif
		exit(0);
	}
#ifdef DEBUG
	fprintf(DBG_FILE, "input: %s  row: %d  col: %d    \n", in_filename, NROW, NCOL);
	fflush(DBG_FILE);
#endif

	fp_in = fopen(in_filename, "r");
	/* writes into orig_arr */
	fill_orig_array(fp_in, in_filename);
	dump_arr();
	fclose(fp_in);

	/* convert original to prepped */
	calc_dims();

	return(0);
}

fill_orig_array(fp_in, in_filename)
FILE	*fp_in;
char	*in_filename;
{
	int 	i, j, digit_cnt=0, tot_row, tot_col;
	char	c, word[15], new_word[15];
	int		cur_row = 0, cur_col = 0;

#ifdef xDEBUG
	fprintf(DBG_FILE, "Enter fill_orig()\n");
	fflush(DBG_FILE);
#endif
	if (fp_in == NULL) {
#ifdef DEBUG
		fprintf(DBG_FILE, "opening input %s failed\n", in_filename);
#endif
		exit(0);
	}
	/*
	 * find the next character position after the 6th newline
	 */
	for (i = 0; i < 6; i++) {
		while ((c = getc(fp_in)) != '\n') { ;}
	}

	cur_row = 0;
	cur_col = 0;

	tot_row = 0;
	tot_col = 0;

	while ((c = getc(fp_in)) != EOF) {
        if ( c == '\015' ) 
        	continue;
		if (( c == ' ') || ( c == '\n')) {
			/* end of word */
			word[digit_cnt]  = '\0';
#ifdef xDEBUG
			fprintf(DBG_FILE, "found word %s\n", word);
			fflush(DBG_FILE);
#endif
			if (cur_row < NROW && cur_col < NCOL) {

				/* record the new word */
				orig_arr[cur_row][cur_col] = atoi(word);
#ifdef xDEBUG
				fprintf(DBG_FILE, "Write to orig row/col %d/%d (%d) \n", 
				cur_row + 1, cur_col + 1, atoi(word));
				fflush(DBG_FILE);
#endif
				tot_col++;
			}
			cur_col++;
			if (cur_col >= NCOL) {
				cur_row++;
				tot_row++;
				cur_col = 0;
				tot_col = 0;
			}
			digit_cnt = 0;
		}else {
			word[digit_cnt++]  = c;
		} /* it's not space or EOL */
	} /* end while */
}


/* turn global orig into global prepped */
calc_dims()
{
	int		flag, row, col;
	int		i_val, tmp_col, tmp_row;
	int		small_row, small_col, big_row, big_col, start_row;
	int	add_Lcol, add_Rcol, add_Trow, add_Brow;

#ifdef xDEBUG
	(void)fprintf(DBG_FILE, "(%s %d) Enter convert_data()\n", __FILE__, __LINE__);
	fflush(DBG_FILE);
#endif

	small_row = NROW - 1;
	small_col = NCOL - 1;
	big_row = 0;
	big_col = 0;
	for (row = 0; row < NROW; row++) {
		start_row = TRUE;
		for (col = 0; col < NCOL; col++) {
			if (orig_arr[row][col] == -9999)
				continue;
			/* found a non-zero in the column */
#ifdef xDEBUG
			(void)fprintf(DBG_FILE, "(%s %d) non-zero in [%d][%d] (%d)\n", 
			__FILE__, __LINE__, row, col, orig_arr[row][col] );
			fflush(DBG_FILE);
#endif
			if (start_row == TRUE) {
				/* this is the first character in the row */
				if (col < small_col) {
					/* this is the new smallest column */
					small_col = col;
				}
				start_row = FALSE;
			}
			/* this could also be the biggest column so far */
			if (col > big_col) {
				big_col = col;
#ifdef xDEBUG
fprintf(DBG_FILE, "(%s %d) at row %d, col is upp'd to %d\n",
__FILE__, __LINE__, row, col);
fflush(DBG_FILE);
#endif
			}

			/* see if this row is the smallest row */
			if (row < small_row) 
				small_row = row;

			/* so far this is the biggest row too */
			big_row = row;
		}
	}
	/* check for no data at all */
	if (small_col > big_col) {
		tmp_col = small_col;
		small_col = big_col;
		big_col = tmp_col;
	}
	if (small_row > big_row) {
		tmp_row = small_row;
		small_row = big_row;
		big_row = tmp_row;
	}
		
#ifdef DEBUG
	fprintf(DBG_FILE, "(%s %d) smR:%d smC:%d  bigR:%d bigC:%d \n", __FILE__, __LINE__,
	small_row, small_col, big_row, big_col);
	fflush(DBG_FILE);
#endif
	add_Trow = small_row;
	add_Brow = NROW - big_row - 1;
	add_Lcol = small_col;
	add_Rcol = NCOL - big_col - 1;

#ifdef DEBUG
fprintf(DBG_FILE, "(%s %d) \n", __FILE__, __LINE__);
fprintf(DBG_FILE, "Original Array is %d x %d\n", NROW, NCOL);
fprintf(DBG_FILE, "Actual Data Array is %d x %d\n",
(NROW - add_Trow - add_Brow), (NCOL - add_Lcol - add_Rcol));
fprintf(DBG_FILE, "first row:%d first col:%d  last row:%d last col:%d \n",
small_row, small_col, big_row, big_col);
fprintf(DBG_FILE, "Add %d rows top, %d rows bottom, %d col left, %d col right\n",
add_Trow, add_Brow, add_Lcol, add_Rcol);
fflush(DBG_FILE);
#endif
	return(0);
}

dump_arr()
{
#ifdef xDEBUG
	int		row, col;

	(void)fprintf(DBG_FILE, "Here's what orig_arr[][] looks like\n");
	for (row = 0; row < NROW; row++) {
		for (col = 0; col < NCOL; col++) {
			fprintf(DBG_FILE, "%d ", orig_arr[row][col]);
		}
		fprintf(DBG_FILE, "\n");
	}
	fflush(DBG_FILE);
#endif
	return(0);
}
