/*************************************************************************/
/* pick.c - PREDICTION VERSION                                          */
/* Cellular Automaton for Urban Growth Simulation, Keith Clarke May 1990 */
/* kclarke@everest.hunter.cuny.edu                                       */
/*************************************************************************/

#include <values.h>
#include <stdlib.h>
#include "defines.h"
#include "localdefs.h"

#ifdef DEBUG
extern FILE *DBG_FILE;
#endif

/*
 * this function will return a number between 0 and 99 inclusive
 */
unsigned short pickr()
{
    return((unsigned short ) ((float) PICKMAX  * rand() / RAND_MAX));  
}

/*
 * this function will return a number between 0 and NROWS-1 inclusive
 */
unsigned short pickrow()
{
    return((unsigned short ) ((float) NROWS  * rand() / RAND_MAX));  
}

/*
 * this function will return a number between 0 and NCOLS-1 inclusive
 */
unsigned short pickcol()
{
    return((unsigned short ) ((float) NCOLS  * rand() / RAND_MAX));  
}
