/*************************************************************************/
/* plot_circle.c - VISUAL.CALIB VERSION                                  */
/* last revised                                                          */
/* Cellular Automaton for Urban Growth Simulation, Keith Clarke May 1990 */
/* kclarke@everest.hunter.cuny.edu                                       */
/*************************************************************************/

#include <stdio.h>
#include "defines.h"
#include "typedefs.h"
#include "graphics.h"
#include "localdefs.h"

#ifdef DEBUG
extern	FILE *DBG_FILE;
#endif


extern int      nrows;
extern int z[NROWS][NCOLS];
extern short int roads[NROWS][NCOLS];
extern short int strata[NROWS][NCOLS];
extern short int bkgrn[NROWS][NCOLS];


void
plot_circle(xc, yc, distance, color)
	double          xc, yc;
	double          distance;
	unsigned long   color; /* light gray or light grey */
{
	double          theta;
	float           deg;
	float           x, y;
	float           vert[2];

	xc *= SIZE;
/*
	yc = nrows - yc;
*/
	yc *= SIZE;
	distance *= SIZE;
	/* Plot a circle at xc, xc with radius distance */
	XSetForeground(thedisplay, imagegc, color);
	XDrawArc(thedisplay, imagewindow, imagegc, (int) (xc - distance), (int) (yc - distance), (unsigned) (2.0 * distance), (unsigned) (2.0 * distance), 0, 360 * 64);

	return;
}
