/*************************************************************************/
/* write_data.c - VISUAL.CALIB VERSION                                   */
/* last revised:                                                         */	
/* Cellular Automaton for Urban Growth Simulation, Keith Clarke May 1990 */
/* kclarke@everest.hunter.cuny.edu                                       */
/*************************************************************************/


#include <stdio.h>
#include "defines.h"
#include "typedefs.h"
#include "localdefs.h"

#ifdef DEBUG
extern	FILE *DBG_FILE;
#endif

extern short int roads[NROWS][NCOLS];
extern short int bkgrn[NROWS][NCOLS];
extern short int strata[NROWS][NCOLS];


void write_grid(head,fname)
ECO_HEADER *head;
char fname[];
{
    int i, j;
    FILE *fp;
    unsigned char outbuf[MAXC];

    fp = fopen(fname, "w");
    if (fp == NULL) {
	printf("ERROR: File %s not created...\n",fname);
	exit(1);
    }
    head->nc = 1;
    head->nbpr = head->ns;
    head->data_type = BYTE;
    write_ecohead(head,fp);
    
    for (i=0;i<head->nl;i++) {
	for (j=0;j<head->ns;j++) {
	    outbuf[j] = (unsigned char) z[i][j];
	}
	fwrite(outbuf, sizeof(*outbuf), head->ns, fp);
    }
    fclose(fp);
}


void write_image(head,fname)
ECO_HEADER *head;
char fname[];
{
    int r,c;
    FILE *fp;
    unsigned short outbuf[MAXC];

    fp = fopen(fname, "w");
    if (fp == NULL) {
	printf("ERROR: File %s not created...\n",fname);
	exit(1);
    }
    head->nc = 1;
    head->nbpr = head->ns * 2;
    head->data_type = SHORT;
    write_ecohead(head,fp);
    for (r=0;r<head->nl;r++) {
	for (c=0;c<head->ns;c++) {
		    outbuf[c] = (unsigned char ) z[r][c];
	}
	fwrite(outbuf, sizeof(*outbuf), head->ns, fp);
    }
    fclose(fp);
}
