/*************************************************************************/
/* close_frames.c - VISUAL.CALIB VERSION                                 */
/* Close all windows, pixmaps, graphic areas and display                 */
/* written by Sal Perez                                                  */
/* last revised 1/21/96, Sal Perez                                       */
/* Cellular Automaton for Urban Growth Simulation, Keith Clarke May 1990 */
/* kclarke@everest.hunter.cuny.edu                                       */
/*************************************************************************/

#include "defines.h"
#include "typedefs.h"
#include "graphics.h"
#include "localdefs.h"

#ifdef DEBUG
extern	FILE *DBG_FILE;
#endif

/* Cleanly remove windows and free all structures used */
void close_frames()
{
	void delay();
	XFreePixmap(thedisplay,growthpixmap);
	XFreePixmap(thedisplay,beginpixmap);
	XFreePixmap(thedisplay,quitpixmap);
	XFreePixmap(thedisplay,beginpixmap2);
	XFreePixmap(thedisplay,quitpixmap2);
	XFreeGC(thedisplay,thegc);
	XDestroyWindow(thedisplay,thewindow);
	XCloseDisplay(thedisplay);
	delay();


}
