/*************************************************************************/
/* draw_text.c - VISUAL.CALIB VERSION                                    */
/* written by Sal Perez, 1/21/96                                         */
/* last revised 2/1/96, Sal Perez                                        */
/* Cellular Automaton for Urban Growth Simulation, Keith Clarke May 1990 */
/* kclarke@everest.hunter.cuny.edu                                       */
/*************************************************************************/

#include <stdio.h>
#include "defines.h"
#include "typedefs.h"
#include "graphics.h"
#include "localdefs.h"

#ifdef DEBUG
extern	FILE *DBG_FILE;
#endif

/* Draws Legend Text describing image colors. This function is also
   called by show_status_window to refresh text if iconize. */
void draw_text()
{
	if (GRID_FLAG == FALSE) {

	XSetForeground (thedisplay, thegc, blue_pixel);
#ifdef SAMPLE
	XDrawString(thedisplay, thewindow, thegc, 30, 565, "ROADS", 5);
	XDrawString(thedisplay, thewindow, thegc, 30, 585, "WATER/EXCLUDED", 14);
	XDrawString(thedisplay, thewindow, thegc, 30, 605, "SEED", 4);
	XDrawString(thedisplay, thewindow, thegc, 30, 625, "Spontaneous Neighborhood Growth", 31);
	XDrawString(thedisplay, thewindow, thegc, 30, 645, "Spontaneous Diffusive Growth", 28);
	XDrawString(thedisplay, thewindow, thegc, 30, 665, "Spread of a Newly Diffused Center", 33);
	XDrawString(thedisplay, thewindow, thegc, 30, 685, "Organic Growth", 14);
	XDrawString(thedisplay, thewindow, thegc, 30, 705, "Road Trip Growth", 16);
#else /* SAMPLE */
	/*
	XDrawString(thedisplay, thewindow, thegc, 30, 565, "ROADS", 5);
	XDrawString(thedisplay, thewindow, thegc, 30, 585, "EXCLUDED      ", 14);
	XDrawString(thedisplay, thewindow, thegc, 30, 605, "SEED", 4);
	XDrawString(thedisplay, thewindow, thegc, 30, 625, "Spontaneous Neighborhood Growth", 31);
	XDrawString(thedisplay, thewindow, thegc, 30, 645, "Spontaneous Diffusive Growth", 28);
	XDrawString(thedisplay, thewindow, thegc, 30, 665, "Spread of a Newly Diffused Center", 33);
	XDrawString(thedisplay, thewindow, thegc, 30, 685, "Organic/Road Growth", 19);
	XDrawString(thedisplay, thewindow, thegc, 30, 705, "Agriculture     ", 16);
	*/
	XDrawString(thedisplay, thewindow, thegc, 30, 565, "ROADS                    ", 25);
	XDrawString(thedisplay, thewindow, thegc, 30, 585, "EXCLUDED                 ", 25);
	XDrawString(thedisplay, thewindow, thegc, 30, 605, "SEED                     ", 25);
	XDrawString(thedisplay, thewindow, thegc, 30, 625, "Spontaneous Growth/Spread", 25);
	XDrawString(thedisplay, thewindow, thegc, 30, 645, "Organic/Road Growth      ", 25);
	XDrawString(thedisplay, thewindow, thegc, 30, 665, "Agriculture              ", 25);
	XDrawString(thedisplay, thewindow, thegc, 30, 685, "Available Desert         ", 25);
#endif /* SAMPLE */

	} else {

	XSetForeground (thedisplay, thegc, blue_pixel);
	/*
	XDrawString(thedisplay, thewindow, thegc, 30, 565, "Undefined", 9);
	*/
	XDrawString(thedisplay, thewindow, thegc, 30, 585, "available                ", 25);
	XDrawString(thedisplay, thewindow, thegc, 30, 605, "agriculture              ", 25);
	XDrawString(thedisplay, thewindow, thegc, 30, 625, "urban                    ", 25);
	XDrawString(thedisplay, thewindow, thegc, 30, 645, "excluded                 ", 25);
	XDrawString(thedisplay, thewindow, thegc, 30, 665, "parks                    ", 25);
	}
}
 
