/*************************************************************************/
/* graphics.h - VISUAL.CALIB VERSION  graphics header file               */
/* Created 01-06-96 by Sal Perez                                         */
/* last revised 01-15-96, Sal Perez                                      */
/* Cellular Automaton for Urban Growth Simulation, Keith Clarke May 1990 */
/* kclarke@everest.hunter.cuny.edu                                       */
/*************************************************************************/

#include "growth_icon"
#include "begin_icon"
#include "quit_icon"
#include "light_begin_icon"
#include "light_quit_icon"


/* Buttons colors */
#define	WHITE	0
#define	BLACK	1
#define NOCOLOR	2

#define BITMAPDEPTH 1
#define BORDER_WIDTH 2
#define MAX_COLORS 28 /* image colors */

/* Declarations */
Display *thedisplay;  /* server connection */
Window thewindow, statuswindow,imagewindow;       /* the physical windows */
int thescreen; /* screen # given by server */

/* area reserved for logo, begin */
/* and quit pixmaps */
Pixmap growthpixmap;
Pixmap quitpixmap;
Pixmap beginpixmap;
Pixmap beginpixmap2; /* lighter begin */
Pixmap quitpixmap2;  /* lighter quit  */

/* colors variables */
unsigned long theforeground, statusforeground, /* black */
		thebackground,statusbackground, /* white */
		border_pixel,     /* colors[0] brown */
		background_pixel, /* colors[1] white */
		white_pixel, 		/* colors[1] white */
		foreground_pixel, /* colors[2] black */
		grey_pixel,       /* colors[3] grey. was circle_pixel */
		green_pixel,      /* colors[4] green. was miscelaneous_pixel*/
		blue_pixel,	    /* colors[5] blue */
		roads_pixel,        /* colors[6] red */
		dim_gray_pixel,     /* colors[7] dim gray */
		dark_slate_gray_pixel, /* colors[8] dark slate gray */
		gray_pixel,        /* colors[9] gray */
		khaki_pixel,        /* colors[10] khaki */
		yellow_pixel,       /* colors[11] yellow */		
		temp_gray_pixel,
		light_gray_pixel,   /* colors[12] light gray*/
		light_grey_pixel,   /* colors[13] light grey*/
		dark_slate_grey_pixel, /* colors[14] dk slate grey*/
		dim_grey_pixel,	    /* colors[15] dim grey*/
		green_yellow_pixel, /* colors[16] green yellow*/
		aquamarine_pixel,   /* colors[17] aquamarine*/
		medium_aquamarine_pixel, /* colors[18] */
		wheat_pixel,	    /* colors[19] wheat*/
		orange_pixel,	    /* colors[20] orange*/
		cyan_pixel,	    /* colors[21] cyan */
		blue_violet_pixel,  /* colors[22] blue violet*/
		navy_blue_pixel,    /* colors[23] navy blue */
		sky_blue_pixel,     /* colors[24] sky blue */
		pink_pixel,	    /* colors[25] pink */
		maroon_pixel,	    /* colors[26] maroon */
		magenta_pixel;	    /* colors[27] magenta */


int gray_colors[255];

XSizeHints thehint,statushint,imagehint;  /* window sizes and position. */
GC thegc, statusgc,imagegc;      /* writable area on windows. */
GC statgc;
Visual		*visual;/* needed for colormap */
KeySym thekey;/* used when q is pressed to quit program.*/
Colormap colormap;
XStandardColormap gray_colormap;
XSetWindowAttributes attrib; /* variable to refresh buttons */
 /* variables to change writable areas */
XGCValues gcvalues, statusgcvalues,imagegcvalues;
XGCValues statgcvalues;
int statusgcvaluemask, statgcvaluemask; /* same as above */

XFontStruct    *font;
Cursor 		thecursor;


XEvent theevent;  /* events to account for, e.g. mouse, keyboard, */


char thebuffer[8]; /* buffer for "q" keypress to quit program */

/*
 * Configuration of sub-windows. Begin, Quit, and Growth logo.
 */
typedef struct _OpaqueFrame {
	Window self;			/* window id, filled in later */
	int x, y;			/* where to create the window */
	unsigned int width, height;	/* width and height of window */
} OpaqueFrame;

OpaqueFrame status;
#define NBUTTONS 3 /* Begin, Quit, and Growth logo. */
#define LEGENDWINDOWS 8
