/*************************************************************************/
/* show_status_window.c  - VISUAL.CALIB VERSION                            */
/* written by Sal Perez                                                  */
/* last revised 1/21/96, Sal Perez                                       */
/* Cellular Automaton for Urban Growth Simulation, Keith Clarke May 1990 */
/* kclarke@everest.hunter.cuny.edu                                       */
/*************************************************************************/

#include "defines.h"
#include "typedefs.h"
#include "graphics.h"
#include "localdefs.h"

#ifdef DEBUG
extern	FILE *DBG_FILE;
#endif
#define OFFSET 10	/* Blank space at left and bottom of window */
#define SCALE_POP 1000	/* Max Populatation */
extern float    last_growth_rate, growth_rate;
extern void draw_text();/* legend text. Refreshes if iconize */

void
show_status_window(gstats)
	GSTATS         *gstats;
{	char            text[12];
	void            f_to_str();


	if (DONE_SCENARIO) {
		XDrawString(thedisplay, status.self, statgc, 0, 200, "   DONE SCENARIO", 16);
		return;
	}
	if (GRID_FLAG) {
		XClearWindow(thedisplay,status.self);
		XDrawString(thedisplay, status.self, statgc, 0, 260, "IMAGE:            ", 18);
		XDrawString(thedisplay, status.self, statgc, 0, 270, GRID_FILE, strlen(GRID_FILE));
		return;
	}
	/* First, the text strings */
	/* Erase the last text strings */

	XSetForeground (thedisplay, statgc, blue_pixel);

	XClearWindow(thedisplay,status.self);

	(void) f_to_str((double) ticktock, 0, text);
	XDrawString(thedisplay, status.self, statgc, 0, 20, "DATE       :", 12);
	XDrawString(thedisplay, status.self, statgc, 80, 20, text, strlen(text) - 2);

	(void) f_to_str((double) growth_rate, 6, text);
	XDrawString(thedisplay, status.self, statgc, 0, 40, "GROWTH RATE:", 12);
	XDrawString(thedisplay, status.self, statgc, 80, 40, text, strlen(text) - 1);

	/* display control parameters */
	XDrawString(thedisplay, status.self, statgc, 0, 70, " GROWTH COEFFICIENTS", 20);

	(void) f_to_str((double) param.diffusion_coefficient, 5, text);
	XDrawString(thedisplay, status.self, statgc, 0, 85, "   Diffusion:", 13);
	XDrawString(thedisplay, status.self, statgc, 85, 85, text, strlen(text) - 1);

	(void) f_to_str((double) param.breed_coefficient, 5, text);
	XDrawString(thedisplay, status.self, statgc, 0, 105, "       Breed:", 13);
	XDrawString(thedisplay, status.self, statgc, 85, 105, text, strlen(text) - 1);

	(void) f_to_str((double) param.spread_coefficient, 5, text);
	XDrawString(thedisplay, status.self, statgc, 0, 125, "      Spread:", 13);
	XDrawString(thedisplay, status.self, statgc, 85,125, text, strlen(text) - 1);

	(void) f_to_str((double) param.slope_resistance, 5, text);
	XDrawString(thedisplay, status.self, statgc, 0, 145, "Slope Factor:", 13);
	XDrawString(thedisplay, status.self, statgc, 85,145, text, strlen(text) - 1);

	(void) f_to_str((double) param.road_gravity, 5, text);
	XDrawString(thedisplay, status.self, statgc, 0, 165, "Road Gravity:", 13);
	XDrawString(thedisplay, status.self, statgc, 85,165, text, strlen(text) - 1);

	/*
	XDrawString(thedisplay, status.self, statgc, 0, 200, "   SELF-MODIFICATION", 20);
	XDrawString(thedisplay, status.self, statgc, 0, 215, "     COEFFICIENTS", 17);

	(void) f_to_str((double) selfmod.critical_high, 6, text);
	XDrawString(thedisplay, status.self, statgc, 0, 230, "Critical High:", 13);
	XDrawString(thedisplay, status.self, statgc, 85, 230, text, strlen(text) - 1);

	(void) f_to_str((double) selfmod.critical_low, 6, text);
	XDrawString(thedisplay, status.self, statgc, 0, 250, " Critical Low:", 13);
	XDrawString(thedisplay, status.self, statgc, 85, 250, text, strlen(text) - 1);

	(void) f_to_str((double) selfmod.boom, 6, text);
	XDrawString(thedisplay, status.self, statgc, 0, 270, "         Boom:", 13);
	XDrawString(thedisplay, status.self, statgc, 85, 270, text, strlen(text) - 1);

	(void) f_to_str((double) selfmod.bust, 6, text);
	XDrawString(thedisplay, status.self, statgc, 0, 290, "         Bust:", 13);
	XDrawString(thedisplay, status.self, statgc, 85, 290, text, strlen(text) - 1);
	*/

	draw_text();
	return;
}
